#!/bin/sh 
#

if test "x$1" = "xrpm" ; then 
    shift
    for i in $* ; do 
	case $i in 
	    *-dev) 						        ;;
	    libroot)							;;
	    root-bin)							;;
	    root-cint)							;;
	    root-doc)							;;
	    *alien)	echo -n ", AliEn-Client" 			;;
# Build dependency on AfterStep-devel temporarily commented out 
# until such a time when ROOT can use the normal libAfterImage.
# Input the build dependencies of the libafterimage-dev package
#	    *asimage)	echo -n ", AfterStep-devel"			;;
	    *asimage)							;;
	    *castor)	echo -n ", CASTOR-client"			;;
	    *chirp)							;;
	    *clarens)							;;
	    *dcache)							;;
	    *fumili)							;;
	    *gl)							;;
	    *globus)	echo -n ", globus"				;;
	    *hbook)	echo -n ", gcc-g77"				;;
	    *krb5)	echo -n ", krb5-devel"				;;
	    *ldap)	echo -n ", openldap-devel"			;;
	    *minuit)							;;
	    *minuit2)							;;
	    *mlp)							;;
	    *mysql)	echo -n ", mysql-devel"				;;
	    *netx)							;;
	    *oracle)    echo -n ", oracle-instantclient-devel"		;;
	    *peac)							;;
	    *pgsql)	echo -n ", postgresql-devel"			;;
	    *proof)							;;
	    *pythia5)	echo -n ", pythia5-devel"			;;
	    *pythia6)	echo -n ", pythia6-devel"			;;
	    *python)	echo -n ", python-devel >= 2.1"			;;
	    *qt)	echo -n ", qt-devel >= 3.3.3 or qt3-devel or libqt3-devel"			;;
	    *quadp)							;;
	    *roofit)							;;
	    *ruby)	echo -n ", ruby-devel >= 1.8"			;;
	    *maxdb)	echo -n ", libsqlod75-dev"			;;
	    *sql)							;;
	    *srp)							;;
	    *venus)							;;
	    *xml)	echo -n ", libxml2-devel"			;;
	    root-proofd)						;;
	    root-rootd)							;;
	    root-xrootd) echo -n ", krb5-devel"				;;
	    ttf-root*)							;;
	    root-common)						;;
	    *) 
		echo "*** Warning *** Unknown package $i - please update $0" \
		    > /dev/stderr 
		;;
	esac
    done
    exit 0
fi    

### echo %%% Making build dependencies
bd=
for i in $* ; do 
    case $i in 
	*-dev)							        ;;
	libroot)							;;
	root-bin)							;;
	root-cint)							;;
	root-doc)							;;
	*alien)		echo -n ", libalien-dev" 			;;
# Build dependency on libafterimage-dev temporarily commented out 
# until such a time when ROOT can use the normal libAfterImage.
#	*asimage)	echo -n ", libafterimage-dev"			;;
# Input the build dependencies of the libafterimage-dev package
#	*asimage)	echo -n ", AfterStep-devel"			;;
	*asimage)	echo -n ", libjpeg62-dev, libpng12-dev, zlib1g-dev (>= 1:1.1.4), libtiff4-dev, libfreetype6-dev, libungif4-dev, libxinerama-dev" ;;
	*castor)	echo -n ", libshift-dev"			;;
	*chirp)		echo -n ", libchirp-dev"			;;
	*clarens)	echo -n ", libxmlrpc-c3-dev | libxmlrpc-c-dev"	;;
	*dcache)	echo -n ", libdcap-dev"				;;
	*fumili)							;;
	*gl)		echo -n ", libglu1-xorg-dev | xlibmesa-glu-dev |  libglu-dev"	;;
	*globus)	echo -n ", globus"				;;
	*hbook)		echo -n ", libpacklib1-dev [!kfreebsd-i386], g77|fortran-compiler" ;;
	*krb5)		echo -n ", libkrb5-dev|heimdal-dev"		;;
	*ldap)		echo -n ", libldap2-dev | libldap-dev"		;;
	*oracle)    	echo -n ", oracle-instantclient-devel"		;;
	*minuit)							;;
	*minuit2)							;;
	*mlp)								;;
	*mysql)		echo -n ", libmysqlclient15-dev | libmysqlclient14-dev | libmysqlclient12-dev| libmysqlclient-dev" ;;
	*netx)								;;
	*peac)								;;
	*pgsql)		echo -n ", postgresql-dev | libpq-dev"		;;
	*proof)								;;
	*pythia5)	echo -n ", pythia5-dev"				;;
	*pythia6)	echo -n ", pythia6-dev"				;;
	*python)	echo -n ", python-dev (>= 2.1)"			;;
	*qt)		echo -n ", libqt3-mt-dev, libqt3-headers, qt3-dev-tools"			;;
	*quadp)								;;
	*roofit)							;;
	*ruby)		echo -n ", ruby (>= 1.8), ruby1.8-dev | ruby-dev (>= 1.8)"	;;
	*maxdb)		echo -n ", libsqlod75-dev [i386 ia64]"		;;
	*sql)								;;
	*srp)		echo -n ", libsrputil-dev"			;;
	*venus)		echo -n ", libvenus-dev"			;;
	*xml)		echo -n ", libxml2-dev"				;;
	root-proofd)							;;
	root-rootd)							;;
	root-xrootd)	echo -n ", libkrb5-dev|heimdal-dev"		;;
	ttf-root*)							;;
	root-common)							;;
	*) echo "*** Warning *** Unknown package $i - please update $0" ;;
    esac
done

#
# EOF
#
